Upgrading
=========


## 3.x to 4.x

*Our JS library has gone through some major improvements, and there are some changes you'll need to make to get onto the new version.*

#### Dropping support for IE6/7

v1 to 3 of the notifier valiantly supported IE 6 and 7. However, supporting these ~old~ ancient browsers came with some pretty serious caveats. Now that we’ve dropped support, we're able to move the library forward and make our reporting delivery mechanism more robust.

If you’re still supporting users on IE6/7, you can still use v3. We will continue to maintain v2 along side v3. For more information, see the [v3 integration guide](TODOTODOTOD).

#### Manual startup

Before, the client would simply "exist" already on the page – like a singleton. Now you have to explicitly create your client with some configuration options (or simply an API key).

This might seem like a little more work, but it gives you more granular control:
- Bugsnag won't start until you tell it to.
- It will do exactly as its told based on the config provided. Previously, it would start doing all the default behavior and you'd have to go and switch it all off, which was rather messy.

##### Before
```html
<script src="//d2wy8f7a9ursnm.cloudfront.net/bugsnag-3.min.js" data-apikey="API_KEY"></script>
<script>
  Bugsnag.notify(err)
</script>
```

##### After
```html
<script src="//d2wy8f7a9ursnm.cloudfront.net/4.x.x/bugsnag.js"></script>
<script>
  const client = bugsnag('API_KEY')
  client.notify(err)
</script>
```

#### Deprecation

We've removed the ability to configure the library with HTML attributes.

#### Configuration

We've changed how our configuration system works. You can now build up our config object in a similar way to how you configured the client in v2, and then pass that as the first paramater when you construct the client object. In addition, we've removed some configuration options in favour of using our new notification pipeline system. Now you can register multiple callbacks to have maximum flexibility. We've also switched to using [Guzzle](http://guzzlephp.org), so you can change the base URI and proxy details by directly interacting with guzzle. For more information, see the [advanced configuration guide](https://docs.bugsnag.com/platforms/php/other/advanced-client-configuration).

#### Customizing handled errors

We have changed how you attach metadata and update the severity of handled errors in `Bugsnag::notify`. Previously metadata and severity were additional parameters to the `notify` method, now the method takes an optional callable with the Error object, so these properties and more can be changed directly. See the documentation for [reporting handled errors](https://docs.bugsnag.com/platforms/php/other/reporting-handled-errors/) for more information.
